 ;									     ;
 ;			   Chargeur du noyau OSLm			     ;
 ;									     ;
			  ; sur PC386 ou compatible
.xlist
if 0		; Remarques prliminaires


Dj fait: Une premire version assemble (22/8/92)
En train : Rien.
A faire  :
	- Voir Amliorations futures
	- Tester le programme sur un 386
	- Ecrire la partie relle du noyau (interface DOS)
En cas de modification:
	- Si le chargeur devient un fichier .EXE, faire alors
	bien attention  l'initialisation des segments, notamment
	dans Chargeur et PileReelle. Si le segment NoyauReel est 
	diviser (d'abord entre code, donnes, pile, tampon ensuite...),
	faire trs attention  l'intrieur de la partie relle du noyau.

Spcifications:
A) Buts:
 1) Chargement
 - Vrifie que le systme est bien  processeur 386 ou suprieur.
 - Vrifie que l'on est pas en mode 8086 virtuel
 - Vrifie qu'il y a assez de mmoire tendue disponible, et la rserver.
 - Charge le noyau OSL dans la mmoire tendue
 - Libre la mmoire occupe par les parties inutiles du chargeur
 2) interface OSLm/DOS
 - Interdit les interruptions, passe en mode protg et appelle le noyau,
  partir d'une TGD spcialement rserve  cet effet.
 - Contient la partie du noyau qui appelle le DOS et/ou le BIOS  partir du
 mode rel et retourne au DOS finalement.
B) Contraintes:
 - utiliser le moins de place possible en mmoire conventionnelle.

Amliorations futures:
 - Prendre le chemin d'OSLm en paramtre
 - Pouvoir charger un fichier de configuration avec OSL, et accepter
 ainsi librairies, options implicites diffrentes de celles prprogrammes,
 et surtout commande auto-xcutable au lancement d'OSL.
 - Pouvoir se passer de serveur XMS en tenant compte de la mthode 15h,
 et de VDISK (au moins, afficher un message prventif !), voire de DPMI/
 VCPI.
 - Afficher les numros d'erreur quand il y en a.
 - Afficher la signification des erreurs !

endif

;;;;;;;;;;;;;;;;;;;;;;;; DIRECTIVES DE COMPILATION ;;;;;;;;;;;;;;;;;;;;;;;;;;;

IDEAL	; commande pour TASM (masm=khrsse, comme tout produit microsoft)
;;; Directives pour le listing
%noctls
%noincl
%noconds
;;%nocref
masm
.xall
ideal
;%syms
;%notrunc
%list	; let's go

P386	; bien sr ! (mode protg permis)

Include "Macro.INC"	; Macros  usage gnral, et programmation structure
Include "Mem386.INC"	; Dfinitions et doc. pour la mmoire tendue

;;;;;;;;;;;;;;;;;;;;;;; TYPES ET STRUCTURES UTILISES ;;;;;;;;;;;;;;;;;;;;;;;;;

;;; voir NOYAU386.OSL

;;;;;;;;;;;;;;;;;;;;;;;; SEGMENTS DU CHARGEUR ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;; il faudra sans doute prcder les segments d'un entte. Mais le chargeur
;;; pourra s'en charger (hh).

Group	OSLC	DonneesNoyauReel,NoyauReel,PileReelle,DonneesChargeur,Chargeur
Assume cs:OSLC,ds:OSLC,es:OSLC,ss:OSLC

Masm	;;; S'assurer que les segments seront ordonns dans leur ordre
.SEQ	;; d'apparition.
Ideal

Segment DonneesNoyauReel para public use16 'Noyau'
	ORG 100H	; (programme .COM)
	jmp near Init	; Ainsi doit s'appeler le programme principal
	ORG 100H	; On peut dfinir des donnes ici mme.
  ;;; Les dfinitions suivantes ne doivent pas craser ce jmp (sur 3 octets)
  ;;; Aussi, faire un ORG 103H, ou dfinir des donnes avec le symbole '?' .
EndS	DonneesNoyauReel
Segment NoyauReel byte public use16 'Noyau'
EndS	NoyauReel
Segment PileReelle para public use16 'Noyau'
EndS	PileReelle
Segment DonneesChargeur para public use16 'Noyau'
EndS	DonneesChargeur
Segment Chargeur para public use16 'Noyau'
EndS	Chargeur

%Incl
Include "OSLC0010.ASM"	; Partie relle du noyau
Include "OSLC0020.ASM"	; Chargeur proprement dit


End	DonneesNoyauReel:100h	;(programme .COM)

