/************************ Program Convertisseur ; ***********************/

/*** These shall be translated to OSL as soon as possible ***/

/*** Other modules used ***/

#include "MyTypes.h"
#include "GetOpt.h"
#include <stdio.h>
/*
#include "MyVIO.h"
#include "FileIO.h"
#include "IOmanage.h"
#include "MonoBufF.h"
#include "VSymbolT.h"
#include "RSymbolT.h"
*/

/*
ConvertTable* convert_table ;
*/

typedef enum { FT_7bit_ASCII, FT_EBCDIC, FT_PCOEM, FT_ISO8859, FT_Mac,
	       FT_VSCII, FT_Saigon, FT_NUMFONTTYPE, FT_Unicode } FontType ;

FontType SourceType = FT_PCOEM ,	/*** Default on system ***/
	 DestType   = FT_PCOEM ;	/*** Default on system ***/
boolean  OutPutCRLF = True ;		/*** Default on system ***/

SetByteParam s_a={&SourceType,FT_7bit_ASCII} ;
SetByteParam s_e={&SourceType,FT_EBCDIC} ;
SetByteParam s_o={&SourceType,FT_PCOEM} ;
SetByteParam s_i={&SourceType,FT_ISO8859} ;
SetByteParam s_m={&SourceType,FT_Mac} ;
SetByteParam s_v={&SourceType,FT_VSCII} ;
SetByteParam s_s={&SourceType,FT_Saigon} ;
SetByteParam s_u={&SourceType,FT_Unicode} ;
SetByteParam d_a={&DestType,FT_7bit_ASCII} ;
SetByteParam d_e={&DestType,FT_EBCDIC} ;
SetByteParam d_o={&DestType,FT_PCOEM} ;
SetByteParam d_i={&DestType,FT_ISO8859} ;
SetByteParam d_m={&DestType,FT_Mac} ;
SetByteParam d_v={&DestType,FT_VSCII} ;
SetByteParam d_s={&DestType,FT_Saigon} ;
SetByteParam d_u={&DestType,FT_Unicode} ;
SetByteParam d_cr_1={&OutPutCRLF,True} ;
SetByteParam d_cr_0={&OutPutCRLF,False} ;
SetByteParam *d_PC[2]={&d_o,&d_cr_1} ;
SetByteParam *d_VS[2]={&d_v,&d_cr_1} ;
SetByteParam *d_A7[2]={&d_a,&d_cr_0} ;
SetByteParam *d_UX[2]={&d_i,&d_cr_0} ;
SetByteParam *d_Mac[2]={&d_m,&d_cr_0} ;
SetByteParam *d_sg[2]={&d_s,&d_cr_0} ;
SetByteList ld_PC={2,&d_PC} ;
SetByteList ld_VS={2,&d_VS} ;
SetByteList ld_A7={2,&d_A7} ;
SetByteList ld_UX={2,&d_UX} ;
SetByteList ld_Mac={2,&d_Mac} ;
SetByteList ld_sg={2,&d_sg} ;


const Option ListOp [] = {
  {  0,  NULL,        PrintSmallHelp,   "" },
  { 'a', &s_a,        SetByte,          "source is 7 bits ASCII" },
  { 'e', &s_e,	      SetByte,          "source is EBCDIC" },
  { 'o', &s_o,	      SetByte,          "source is PC OEM" },
  { 'i', &s_i,	      SetByte,          "source is ISO-8859" },
  { 'm', &s_m,	      SetByte,          "source is EBCDIC" },
  { 'v', &s_v,	      SetByte,          "source is VSCII" },
  { 's', &s_s,	      SetByte,          "source is Saigon" },
  { 'u', &s_u,	      SetByte,          "source is Unicode (16 bits)" },
  { 'A', &ld_A7,      SetMultipleBytes, "Destination is 7 bits ASCII" },
  { 'E', &d_e,	      SetByte,          "Destination is EBCDIC" },
  { 'O', &ld_PC,      SetMultipleBytes, "Destination is PC OEM" },
  { 'I', &ld_UX,      SetMultipleBytes, "Destination is ISO-8859" },
  { 'M', &ld_Mac,     SetMultipleBytes, "Destination is MacIntosh" },
  { 'V', &ld_VS,      SetMultipleBytes, "Destination is VSCII" },
  { 'S', &ld_sg,      SetMultipleBytes, "Destination is Saigon" },
  { 'U', &d_u,	      SetByte,          "Destination is Unicode" },
  { 'c', &OutPutCRLF, SetFalse,         "Don't put CRs before LFs"},
  { 'C', &OutPutCRLF, SetTrue,          "Do put CRs before LFs"},
};


char * Args [] = {"-","-"} ;
/***
VIstream *I ;
VOstream *O ;

OpenFiles ()
{
  I=OpenFile (Args[0],"rb") ;
  O=OpenFile (Args[1],"wb") ;
}
***/

/********
void WriteO (translate *T,INPUT *IN,OUTPUT *OUT)
{
  puts(OUT->file,T->o) ;
}

void Convert_one (INPUT *IN,OUTPUT *OUT)
{
  translate * T ;
  T = LongestMatch (&IN,c_table_t) ;
  (*(T->op))(T,IN,OUT) ;
}

void DoConvert (void)
{
  while (!Feof(&INfile)) Convert_one (&INfile,&OUTfile) ;
}
**********/

int main (int argc, char **argv)
{
  Word bidon ;

  InitGetParam(argc,argv) ;
  HelpText = "Va te faire voir !\n";
  ParamNumber = 2 ;

  GetParam(&ListOp,sizeof(ListOp)/sizeof(ListOp[0]),&bidon,Args) ;

/*  GetTable () ;
  OpenFiles () ;
  DoConvert () ; */
  return 0;
}

/***
  Dans une version ultrieure, tenir compte de chemins possibles
pour aller d'un codage  un autre. Ne pas crire cette version en
C, mais en OSL, qui supporte le multithread; il y aura une thread
par tape de traduction. Chaque tape sera un DoConvert avec la
table approprie depuis l'tape prcdente vers l'tape suivante;
la premire tape lit l'entre, la dernire crit dans la sortie.
***/
