////////	CLASSES "Type","Value" , "Label" et "Operator"

/*
  Ces classes servent  grer les symboles du compilateur configurable,
*/

struct	Type
{
  char  *Name		;
  Word	(*Len)  (char*) ;// renvoie la longueur d'un objet point du type
  void	(*Disp) (char*) ;// affiche un objet point du type
};

class	Value
{
  Value *Previous,*Next ;
  char	*Type, *Val ;
  Value (Value*) ;
};
Value::Value (Value*VP)
 {
  Previous = VP ;
  Next = NULL ;
  Type = NULL ;
  Val  = NULL ;
 }

class	Label
{
  char*	Name ;
  Word	Nlen ;
  Value* FirstValue ;

  friend  Word CreateLbl (const char*,Word);
  friend dword SearchLbl (const char*,Word);
  friend  Word CompareLbl(Word,const char*,Word);
	//  Le dernier oprande est la longueur de la chane .
	//  Le mot renvoy est le numro d'entre dans la table LblVTbl .
	//  Le mot haut de SearchLbl() indique le numro dans la table
	// LblNum, le mot bas indiquant selon le signe, le rsultat de la
	// comparaison .

};
stack	LblVTbl = stack ( 0,4 ) ;	// Tableau des tiquettes
#define	LblVal	((Label*)(LblVTbl.cars))
stack	Labels  = stack ( 0,4 ) ;	// classement lexicographique des
					// tiquettes
#define LblNum  ((Word)(Labels.cars))
Word	NumOfLbl ;		// Nombre d'tiquettes

Word	CompareLbl(Word num,const char*name,Word len);
{ // renvoie
  //  en haut : un nombre <0 ,=0 , ou >0 selon que le nom de l'tiquette
  // indique par num soit infrieur, gal, ou suprieur selon l'ordre
  // lxicographique au nom pass en paramtre
  //  en bas : la longueur compare
 Label	*L = &LblV[num] ;	// l'tiquette  comparer
 Word	Mlen,mlen, 			// longueur des chanes
	WhichIsLonger,			// <0:Lbl , =0:== , >0:string
	i ;
 char	d ;
 Mlen = L->Nlen ;
 mlen = len ;
 WhichIsLonger = Mlen-mlen ;
 if (WhichIsLonger<0)
   { mlen = Mlen ; Mlen = len ;}
 for ( i=0,d=0 ; i<l ; i++ )
  {
   d = LblV[num].Name[i] - name[i] ;
   if (d!=0) return WORD (d,i) ;
  }
 return WORD (WhichIsLonger,L) ;
}

dword	SearchLbl (const char*c,Word l);
{
//  Le mot haut de SearchLbl() indique le numro dans la table LblNum,
// le mot bas indiquant selon le signe, le rsultat de la comparaison .
 register Word
   try ,
   try1,
   inc ;
 register dword
   res ;
 for ( res=0L,try=0,inc = 0x8000 ; inc <> 0 ; inc >>= 1 )
  { if ( try+inc < NumOfLbl ) break ;}
 do
  {
   try1 = try + inc ;
   if ( try1 >= NumOfLbl ) continue ;
   inc >>= 1 ;
   res = CompareLbl ( LblNum[try1],c,l ) ;
   if ( res < 0 ) break ;
   if ( LHi(res) = 0 ) return LONG (try1,LLo(res)) ;
   try = try1 ;
  }
 while ( inc <> 0 )
 do
  {
   try1 = try + inc ;
   res = CompareLbl ( LblNum[try1],c,l ) ;
   if ( (char)res  =0 ) return LONG (try1,res) ;
   if ( (char)res >=0 ) try = try1 ;
   inc >>= 1 ;
  }
 while ( inc <> 0 )
  try1=try ;
  return LONG (try1,res ) ;
}

Word	CreateLbl (const char*c,Word l);
{
 Value *Val ;
 dword Srch = SearchLbl (c,l) ;
 if ( (char) Srch == 0 )	// existe dj
   {
    for (Val=LblVal[LHi(Srch)].FirstValue; Val->Next <> NULL;)
	 Val=Val->Next;
    Val->Next = new Value (Val);
   }
 else				// nouvelle tiquette
   {
   Val
   // ici, de la mthode de gestion de la mmoire dpend le code ;
   LblVTbl.Push(Lbl) ;		// on place Lbl dans la table LblVTbl
   Labels.insert( NumOfLbl++,LHi(Srch) );  // et son numro dans la table
				// Labels classe par ordre alphabtique
   }
}

struct	Operator
{
//  double (*Eval) (dstack&) ; // programme d'valution effective

  char*	(*tostring) (stringo&) ;//  programme renvoyant la chane de
				// caractres correspondant  l'objet
  Word	OpNmbr ,
	isTerminal    :1 , // 1 si fin d'expression
	isCommutative :1 , // 1 si l'on peut permuter circulairement les
			   // oprandes
	isAssociative :1 , // 1 si l'opration est commutative
	isReal	      :1 ; // 1 si  valeur relle , 0 si  valeur entire
 // ...
};

