////////		CLASSE "Expression"


class	Expression
{
public:
  Type*		pType		;//  type de l'expression
  Word		key		;//  nombre caractrisant la nature de
				 // l'expression (somme, produit , ...)
  Word		len		;

	Expression (stringo&S)	;
	Expression (const char*C) {Expression(stringo(C));}
	Expression (PostFixedE&);
  stringo*	string ()	;
  PostFixedE*	PostFixedVal ()	;

private:
	Expression (Word,...) ;
	~Expression () ;

};

////////		VARIABLES GLOBALES

struct	{ Word eofI:1, PASS2:1 ;}	flags = {0,0,0};




////////

void
/*!!!*/	OpenStruc	(void),		// ouvre une structure (macro)
/*!!!*/	CloseStruc	(void);		// la ferme (dtruit ses variables)
int	GetLexU		(void),
	IN1		(void),
	IN2		(void),
	NextLU	   (register int p),
	nop		(int c)		{ return(c); }


char	huge *TxtBot;		// pointeur du haut du 'texte'
int	LexSeg,			// segment des units lexicales
	LexUtop=0,		// pointeur ...
	structdepth,		// profondeur de structure
	(*upcase)(int)=toupper,	// procdure de mise en majuscule
	(*_IN_)(void);



Expression::Expression(stringo& In)
{
 stack st (64,4); // pile de structures puis de donnes
 stack Out  (64,4);
 dword a;
 char c;

//  1re partie: division de l'expression en units lxicales

while (!In.end())	//********* prise d'units lexicales **********
 {			//************* jusqu' la fin ********
 while(isspace(c=In.get()));	// ne pas tenir compte des espaces.

 if ( c=='$' )			//******* nombre hexadcimal
  {
  c = HexDigit(In.get()) ;
  if ( c = -1 )
    {
     In.back() ;
     c = '$' ;
    }
  else
    {
     Out.push(0L);		// crire l'indicatif d'un nombre entier
     a = 0 ;
     do
     {
      a = (a<<4) + c ;
      c = HexDigit(In.get()) ;
     }
     while (c>=0) ;
     Out.push(a) ;
     In.back() ;
    }
  }
 else
 if ( isdigit(c) )		//******* nombre
  {
   double d;
   char   i;
   Out.push(0L);		// crire l'indicatif d'un nombre entier
   a = getint() ;		// crire l'entier pris ( dans w )
   write ( a );
   i = 0 ;			// indique que le rsultat est entier
   c = In.get() ;
   if ( c=='.' )
    {
     i = 1 ;			// indique qu'il est rel
     for ( d = a , double x = .1 ;
	   isdigit (c=In.get()) ;
	   x /= 10 )
	d += (c&0xf) * x ;
    }
   if ( c=='E' || c=='e' )
    {
     c = In.get() ;
     if ( isdigit(c) )
      {	if (i==0) d = a ;	// le rsultat tait entier
	i = 1 ;
	d *= pow10 ( getint () );
      }
    }
   if (i)			// si le rsultat est rel
    {
     ptr -= sizeof(Word) + sizeof(dword) ;
     Out.push((int)1) ;
     Out.Push( d ) ;
    }
   continue ;
  }


 if (c=='/')		// '/' suivi de '/' ou '*', annonce des commentaires
   {
   c=In.get();
    if	(c=='/')
	{ while (!(IN==CR||flags.eofI));;}
    else
    if  (c=='*')
	{ skipcomments(); continue }
    else
    In.ptr----
   }

 /*  Si ce n'est ni un nombre, ni un dbut de commentaire, chercher ce que
   c'est parmi la liste des tiquettes et symboles .			  */

  a = SearchLbl (In.cars+In.ptr,MAX(In.len+1-In.ptr,255) ) ;
  if ((char)a == 0) erreur (LabelNotFound) ;
  In.ptr += (char)a ;
  write LHi(a) ;

  switch ( LblV[LLo(a)].FirstValue->Type )
   {
    case StructureOpener   :
			Out.		// sortir la prsence de la structure
			Out.		// rserver de la place pour sa taille
			st.		// sauver son adresse
    case StructureCloser   :
			st.		// slectionner la dernire structure
			Out.		// vrifier qu'elle est de mme nature
			Out.		// si oui, stoquer sa taille
			Out.		// continuer la suite
    case Special	   :
			......		// lancer la routine correspondante
   }


if (st.size) 		//  Quand on estla fin, tester que les
      erreur (OpenParenthesis) ;// parenthses ont bien t refermes .
   return ;

//  2me partie: arborisation de l'expression
// ( automate )

//  3me partie: simplification de l'arbre

}		//  Expression::Expression(stringo&)


////////////////////////// limite de programmation //////////////////////
// Ceci n'est plus programm

int IN1(void)
{
 register r=fgetc(I);
 if feof(I) flags.eofI=1;
 return r;
}

int IN2(void)
{
 int r=IN1();
 Ligne [LnPtr]=r;
 if (LnPtr++==-1) erreur (LineTooLong);
 return r;
}


int NextLU (register p) /* OK */
{
  switch (*LexUp(p++))
   {
   case integer:p+=sizeof(int); break;
   case label:	p+=*LexUp(p); break;
   case '(':	p+=*(int*)LexUp(p); break;
   }
  return p;
}

long GetVal (Word LUmin,Word LUmax)	/* OK */
{	/* LLo = la valeur; LHi = pointeur vers LUmax effectif */
 register Word	p; 		/* pointeur sur les units lexicales */
 union {
	Label far* L;
	dword l ;
	Word i ;
	char priority;
	struct
	 {char L,H;	/* H:Next Expected Lexical Unit Type 1:value,0:op*/
	 Word lpop;}	/* pointeur sur l'oprateur le moins prioritaire */
	  x;
       } R ;
#define Priority(PrLvl)	if(PrLvl<R.priority){R.x.lpop=p;R.priority=PrLvl;}
 GV0:
 p=NextLU(LUmin);
 if (p>LUmax) erreur (NullLU);
 if (p==LUmax)
  {
  GV1:
  switch (*LexUp(LUmin))
   {
   case integer: return LONG(LUmax,*(int*)LexUp(LUmin+1));
   case label:	 R.L=SearchLbl(LexUp(LUmin+1));
		 return LONG(LUmax,((R.L==NULL)?0:R.L->val));
   case '(':	 LUmin+=3; goto GV0;  /* <=> return GetVal(LUmin+3,LUmax); */
   default:	 erreur (ValueExpected);
   }
  }
 /*  p < LUmax */
 for (p=LUmin,R.i=0x10C /* R.x.H=1,R.priority=12 */;p<LUmax;p=NextLU(p))
  if (R.x.H)	/* a label, a number or a unary operator is expected */
   switch (*LexUp(p))
    {
    case '!':
    case '~':
    case '-':
    case '+':		Priority(11);break;
    case '(':
    case label:
    case integer:	R.x.H=0;break;
    default:		erreur(ValueExpected);
    }
  else		/* binary operator is expected */
   {
   switch (*LexUp(p))
    {
    case '*':
    case '/':
    case '%':		R.x.H++;
    case '-':
    case '+':		R.x.H++;
    case shr:
    case shl:		R.x.H++;
    case '<':
    case le:
    case '>':
    case ge:		R.x.H++;
    case eq:
    case ne:		R.x.H++;
    case '&':		R.x.H++;
    case '^':		R.x.H++;
    case '|':		R.x.H++;
    case and:		R.x.H++;
    case or:		R.x.H++; Priority(R.x.H);break;
    case CR:
    case ';':
    case ',':
    case label:		/* <=> return GetVal (LUmin,p); */
    case integer:	LUmax=p;
			if (R.priority==12) goto GV1;else goto GV2;
    default:		erreur(OperatorExpected);
    }
   }
 GV2:
 if (R.priority==11)	/* unary operator */
  {
  if ((p=*LexUp(R.x.lpop))=='+')
    {  LUmin++; goto GV1 ; }
  R.l=GetVal(R.x.lpop+1,LUmax);
  switch ( (char)p )
   {
   case '-':R.i=-R.i;break;
   case '!':R.i=!R.i;break;
   case '~':R.i=~R.i;break;
   }
  } /* if unary op */
 else
  {
  p=GetVal(LUmin,R.x.lpop);
  LUmin=*LexUp(R.x.lpop);
  R.l=GetVal(R.x.lpop+1,LUmax);
  switch (LUmin)
   {
   case '*':R.i*=p; break;
   case '+':R.i+=p; break;
   case '&':R.i&=p; break;
   case '^':R.i^=p; break;
   case '|':R.i|=p; break;
   case '/':R.i=p/R.i; break;
   case '%':R.i=p%R.i; break;
   case '-':R.i=p-R.i; break;
   case shr:R.i=p>>R.i; break;
   case shl:R.i=p<<R.i; break;
   case '<':R.i=p< R.i; break;
   case le: R.i=p<=R.i; break;
   case '>':R.i=p> R.i; break;
   case ge: R.i=p>=R.i; break;
   case eq: R.i=p==R.i; break;
   case ne: R.i=p!=R.i; break;
   case and:R.i=p&&R.i; break;
   case or: R.i=p||R.i; break;
   }
  }
 return R.l;
}
