;;  LIBRAIRIE DE MACROS
; (c) Far 1992

if 0	; (Remarques)
======================== Cette librairie contient ==========================;
Des abbrviations pour WORD PTR,BYTE PTR,OFFSET,JUMP SHORT.

Des macros  usage gnral
-Ldea		est un lea rapide en mode direct
-Clr		efface un registre ou une case mmoire
-Setf		positionne SF,ZF,PF sur un registre, efface CF et OF
-IsReg		rend le nombre Answer non nul ssi le paramtre est un registre
-Max		qui affecte  %1 le plus grand de %2 et %3
-Min		qui affecte  %1 le plus petit de %2 et %3
-fction		qui initialise ax avec les numros de fonction et
		sous-fonction prciss pour un appel au Dos ou au Bios
-functn		qui agit de mme pour un registre gnral prcis quelconque
-MsDos		qui appelle le Dos (int 21h) avec fonction si prcise

Des macros permettant une programmation structure:
- macro-piles:			stklvl,@push,@pop
- chanes de caractres:	EnlevePremierCaractere,PremierCaractere
- Saut anti-conditionnels:	@NCC,@JN
- structures conditionnelles:	@if ... (@else ...) @endif
- structures de boucle:		@repeat ... @until
- structures de boucle:		@while ... @do ... @wend
- sortie de structure(s):	@exit

Des structures classiques de donnees
- ListeChaineeProche

Des macros permettant l'exportation de donn

Endif	; (Remarques)

;;ABBREVIATIONS
BY	equ	byte ptr
WO	equ	word ptr
DWO	equ	dword ptr
PWO	equ	pword ptr
OFS	equ	offset
SH	equ	short


;;MACROS D'AMELIORATION DU JEU D'INSTRUCTIONS

Macro	Ldea	reg,lbl		;lea sur 3 octets au lieu de 4
	mov     &reg,offset lbl
	EndM
Macro	Clr	op		;efface un registre, ou une case mmoire
	IsReg	op
	if	Answer
	xor	op,op
	else
	mov	op,0
	endif
	EndM
Macro	Setf	op		;positionne ZF,PF,SF sur reg
	IsReg	op
	if	Answer
	or	op,op
	else
	test	op,-1
	endif
	EndM

;MACROS POUR PSEUDO-OPERATION
Macro	Max	dest,orig1,orig2
	if	orig1 gt orig2
	dest  =	orig1
	else
	dest  =	orig2
	endif
	EndM

Macro	Min	dest,orig1,orig2
	if	orig2 gt orig1
	dest  =	orig1
	else
	dest  =	orig2
	endif
	EndM

Macro	IsReg	param
  Answer = 0
  irp	extens,<>,<e>
    irpc	genreg,<abcd>
      irpc	suffix,<hlx>
	ifidni	extens&genreg&suffix,param
	  Answer = 1
	endif
      endm
    endm
    irp	indexreg,<si>,<di>,<bp>,<sp>
      ifidni	extens&indexreg,param
	Answer = 1
      endif
    endm
  endm
EndM

Macro	AlignP	paraf,offset
	shift =	($-0&offset) mod paraf
	if	shift
	db	(paraf-shift) dup(90h)	;NOP's
	endif
	EndM
;PS:(!) existe dj en MASM 5.0 (sauf offset) sous le nom (premier) de ALIGN
Purge AlignP

;;MACROS A USAGE GENERAL

Macro	MsDos	func,subfc
	fction	func,subfc
	int	21h
	EndM
Macro	Bios	func,subfc
	fction	func,subfc
	int	10h
	EndM
Macro	fction	fnctn,sbfnc
	functn	a,fnctn,sbfnc
	EndM
Macro	functn	genreg,funct,sbfct
	ifnb	<&funct>
	ifnb	<&sbfct>
	mov	genreg&x,funct*100h+sbfct
	else
	mov	genreg&H,funct
	endif
	else
	ifnb	<&sbfct>
	mov	genreg&L,sbfct
	endif
	endif
	EndM

;;DEFINITION DE CONSTANTES
;   codes ASCII
LF	=	0Ah
CR	=	0Dh
Escape	=	1Bh
;   codes de touches du clavier
K_Home	=	47h
K_Up	=	48h
K_PgUp	=	49h
K_Lft	=	4Bh
K_Rgt	=	4Dh
K_EndC	=	4Fh
K_Dn	=	50h
K_PgDn	=	51h
K_InsC	=	52h
K_Del	=	53h


;;;;;;;;;;  Programmation structure : Pile dans le prprocesseur
STRUCstkPtr = 0

Macro	StkLvl	Var,Stk,Lvl
   Var	CATSTR	<Stk>,%(Lvl)
EndM
Macro	@PUSH	Stk,Val
   LOCAL	StkPtr,StkLvl
   StkPtr	CATSTR	<Stk>,<Ptr>
   % StkPtr	= StkPtr + 1
   StkLvl	CATSTR	<Stk>,%(StkPtr)
   % StkLvl	EQU     Val
EndM

Macro	@POP	Dest,Stk
   LOCAL	StkPtr,StkLvl,Val
   StkPtr	CATSTR	<Stk>,<Ptr>
   ERRIFE       (&StkPtr)
   StkLvl	CATSTR	<Stk>,%(StkPtr)
   Val		EQU	<Dest>
   % Val	EQU	% StkLvl
   % StkPtr	= StkPtr - 1
EndM

;;;;;;;;;;  Programmation structure : manipulation de chaines de caractres

Macro   EnlevePremierCaractere      STR0,DEST
   LOCAL  COUNT
   COUNT = 0
   DEST EQU <>
   IRPC C,STR0
   IF COUNT
   DEST CATSTR DEST,<C>
   ENDIF
   COUNT=1
   ENDM
ENDM
;;; Se rvle maintenant quivalent  % DEST SUBSTR <STR0>,2

Macro   PremierCaractere      STR0,DEST
   IRPC C,STR0
   DEST EQU C
   EXITM
   ENDM
ENDM
;;; Se rvle maintenant quivalent  % DEST SUBSTR <STR0>,1,1

;;;;;;;;;;  Programmation structure : ngation de code condition

Macro	@NCC	cc,ncc
  LOCAL FOUND,CC0
  FOUND = 0
  PremierCaractere   CC,CC0
  % IFidni    <CC0>,<p>
    % IFidni  <CC>,<po>
      &NCC EQU <pe>
      FOUND=1
    % ELSE
      % IFidni  <CC>,<pe>
	&NCC EQU <po>
	FOUND=1
      % ENDIF
    % ENDIF
  % ENDIF
  IF Found
    EXITM
  ENDIF
  % IFidni    <CC0>,<n>
  EnlevePremierCaractere CC,NCC
  % ELSE
    &NCC EQU n&CC
  % ENDIF
EndM


Macro   @JN     cc,Lbl,a1,a2,a3,a4,a5,a6
	LOCAL   NCC,JNCC
	@NCC    CC,NCC
	JNCC    CATSTR  <j>,NCC
	% JNCC    Lbl a1 a2 a3 a4 a5 a6
ENDM

;;;;;;;;;;  Programmation structure : IF ... ( ELSE ...) ENDIF
IFNUM = 0
@EXIT@IF	EQU  @ELSE
@EXIT@ELSE	EQU  @ELSE

Macro   @IF     cc
	Local   LBL
	IFNUM = IFNUM + 1
	@PUSH   STRUCSTK,    %(IFNUM)
	@PUSH	STRUCSTK,    <@IF>
	LBL	CatStr       <@IF>,%(IFNUM)
	@JN     CC,Short LBL
ENDM

Macro	@ELSE
	Local	IFNUM,IFLBL,ELSELBL,StrucName
	@POP	STRUCname,STRUCSTK
	ERRIFDIF	STRUCname,<@IF>
	@POP	IFNUM,STRUCSTK
	STRUCstkPtr = STRUCstkPtr + 1	;;; Rempiler ifnum
	@PUSH	STRUCSTK,<@ELSE>
	IFLBL   CATSTR <@IF>,%(IFNUM)
	ELSELBL CATSTR <@ELSE>,%(IFNUM)
	% jmp	short ELSELBL
	% IFLBL :
ENDM
Macro	@ENDIF
	Local	IFNUM,LBL,StrucName
	@POP	STRUCname,STRUCSTK
	@POP	IFNUM,STRUCSTK
	IFDIF	STRUCname,<@IF>
	  ERRIFDIF	STRUCname,<@ELSE>
	ELSE
	  LBL   CATSTR <@IF>,IFNUM
	  % LBL :
	ENDIF
	LBL   CATSTR <@ELSE>,IFNUM
	% LBL :
ENDM

;;;;;;;;;;  Programmation structure : REPEAT ... UNTIL
REPEATNUM = 0
@EXIT@REPEAT	EQU  @UNTIL

Macro   @REPEAT
	Local	LBL
	@PUSH	STRUCSTK,    %(REPEATNUM)
	@PUSH	STRUCSTK,    <@REPEAT>
	LBL	CatStr       <@REPEAT>,%(REPEATNUM)
	% LBL :
	REPEAT = REPEATNUM + 1
ENDM

Macro	@UNTIL	cc
	Local	REPEATNUM,LBL,StrucName
	@POP	STRUCname,STRUCSTK
	ERRIFDIF	STRUCname,<@REPEAT>
	@POP	REPEATNUM,STRUCSTK
	LBL	CATSTR <@REPEAT>,%(REPEATNUM)
	@JN	cc,< short LBL >
	LBL	CATSTR <@UNTIL>,%(REPEATNUM)
	% LBL :
ENDM

;;;;;;;;;;  Programmation structure : WHILE ... DO ... WEND
WHILENUM = 0
@EXIT@WHILE	EQU  @WEND
@EXIT@DO	EQU  @WEND

Macro	@WHILE
	Local	LBL
	@PUSH	STRUCSTK,    %(WHILENUM)
	@PUSH	STRUCSTK,    <@WHILE>
	LBL	CatStr       <@WHILE>,%(WHILENUM)
	% LBL :
	WHILENUM = WHILENUM + 1
ENDM

Macro	@DO	cc
	Local	WHILENUM,LBL,StrucName
	@POP	STRUCname,STRUCSTK
	ERRIFDIF	STRUCname,<@WHILE>
	@POP	WHILENUM,STRUCSTK
	@PUSH	STRUCSTK,%(WHILENUM)
	@PUSH	STRUCSTK,<@DO>
	LBL	CATSTR <@WEND>,%(WHILENUM)
	@JN	cc,short LBL
ENDM

Macro	@WEND
	Local	WHILENUM,LBL,StrucName
	@POP	STRUCname,STRUCSTK
	ERRIFDIF	STRUCname,<@DO>
	@POP	WHILENUM,STRUCSTK
	LBL	CATSTR <@WHILE>,%(WHILENUM)
	% jmp	LBL
	LBL	CATSTR <@WEND>,%(WHILENUM)
	% LBL :
ENDM

;;;;;;;;;;  Programmation structure : FOR ... NEXT (STEP)
IFDEF __FOR__

FORNUM = 0
@EXIT@FOR	EQU  @XFOR
@EXIT@LOOP	EQU  @XFOR

Macro	@FOR	I,Egal,I0,UpOrDownTo,I1,signed,NoPreTest
	Local	LBL,XLBL,CC
	% mov	I,I0
    ;;; trouver la condition
	% ifidni <UpOrDownTo>,<TO>
	 ifdef signed
	  CC EQU le
	 else
	  CC EQU be
	 endif
	% else
	 % errifdifi <UpOrDownTo>,<DOWNTO>
	  ifdef signed
	   CC EQU ge
	  else
	   CC EQU ae
	   % ifidni <I>,<CX>
	    if	I1 EQ 1
	      @PUSH	STRUCSTK,%(FORNUM)
	      @PUSH	STRUCSTK,<@LOOP>
	      ifndef	NoPreTest
		jcxz	XLBL
	      endif
	    endif
	   % endif
	  endif
	% endif
    ;;; Dfinitions
	LBL	CatStr	<@FOR>,%(FORNUM)
	XLBL	CatStr	<@XFOR>,%(FORNUM)
	@PUSH	STRUCSTK,I1
	@PUSH	STRUCSTK,I
	@PUSH	STRUCSTK,CC
	@PUSH	STRUCSTK,%(FORNUM)
	@PUSH	STRUCSTK,<@FOR>
    ;;; faire une boucle while !!!
	ifndef	NoPreTest
	  % cmp	I,I1
	  % @JN	cc,short XLBL
	endif
	% LBL :
	FORNUM = FORNUM + 1
ENDM

Macro	@NEXT
	Local	FORNUM,LBL,XLBL,CC,StructName,I1,I,I2
	@POP	StructName,STRUCSTK
	@POP	FORNUM,STRUCSTK
	LBL	CATSTR <@FOR>,%(FORNUM)
	XLBL	CATSTR <@XFOR>,%(FORNUM)
   ;;; Vrifier qu'il y a bien une boucle FOR
	% ifdif <StructName>,<@FOR>
	% errifdif <StructName>,<@LOOP>
	 Loop	LBL
	 % XLBL :
	 ExitM
	% endif
	@POP	CC,STRUCSTK
	@POP	I,STRUCSTK
	@POP	I1,STRUCSTK
	% ifidn	<cc>,<le>
	dec	I
	I2 = I1-1
	% endif
	% ifidn	<cc>,<be>
	dec	I
	I2 = I1-1
	% endif
	% ifidn	<cc>,<ge>
	inc	I
	I2 = I1+1
	% endif
	% ifidn	<cc>,<ae>
	inc	I
	I2 = I1+1
	% endif
	if i2
	% cmp	I,I1
	% jz	short LBL
	endif
	% XLBL :
EndM
ENDIF

;;;;;;;;;;  Programmation structure : EXIT
Macro	@EXIT	n,cc
	Local	REPET,NUM,LBL,StructName,Val
	% ifb	<cc>
	cc equ mp
	% endif
	NUM = STRUCstkPtr
	Val EQU <StructName>
	% ifdef n
	% rept	n-1
	StkLvl	LBL,STRUCstk,NUM
	% Val EQU LBL
	% ifdif <StructName>,<@FOR>
	NUM = NUM - 3
	% endif
	NUM = NUM - 2
	% endm
	% endif
	% LBL	CATSTR <@EXIT>,<StructName>
	LBL	CATSTR LBL,%(NUM)
	% j&cc	short LBL
EndM

;;;;;;;;;;;;;;;;;;;; Structures classiques de donnees ;;;;;;;;;;;;;;;;;;;;;;;

Struc	ListeChaineeProche
   Precedent	dd	?
   Suivant	dd	?
EndS
