 ;									     ;
 ;			    Noyau OSLm prversion 0.01			     ;
 ;									     ;
			  ; sur PC386 ou compatible
.xlist
;;; Assembler ce fichier avec			tasm osl0001n osln
;;; Linker ce fichier avec			tlink osln /3
;;; Convertir ce fichier avec			exe2bin osln OSLm-Ker.386
;;; Dtruire les fichiers intermdiaires avec	del osln.*

if 0	; Remarques prliminaires

Dj fait:
  Noyau:-
	-
En train:
  Noyau:-
	-
A faire: Tout le reste !!!!!

 ;									     ;
 ;				  Spcifications			     ;
 ;									     ;

Nature du projet
 Allez voir le rpertoire SPEC
 Routines souvent utilises.
 - Types d'objets grs par le Noyau
  Segment NoyauMemES
    Gestion Mmoire de base
    * zone de mmoire relle
    * table de descripteur
    * tche
   Gestion Mmoire Virtuelle
    (pas pour cette version du noyau, mais la mmoire virtuelle pourra
     tre utile  la gestion de fichiers disques mapps sur la mmoire,
     ou  l'utilisation simple (mais ralentie) d'objets normes de
     plusieurs dizaines de mga-octets, etc...)
   Gestion Mmoire volue
    * ZOT
    * pile systme
  Segment NoyauLangage
   Types de base du langage OSL
    Nombre Entier
    (pour la suite, entiers en base n, modulo n;
    nombres rels de tailles diverses, etc...)
   Constructeurs Rels pour la Programmation
    Fonction
    Tableau
    Pile
   (...tout ce qu'il y a dans le Knuth)
  Constructeurs Virtuels pour la Programmation
   * Fonction virtuelle
   * Ensemble virtuel
   * pointeur virtuel
   (...tout ce qu'il y a dans le Knuth)
  Classes du langage OSL.
   * les chanes de caractres
   * des piles d'objets, en nombre limit par la mmoire seulement

-Utilisation des registres et de la mmoire, conventions d'appel des
 procdures, etc...: voir le fichier SPEC\NOYAU386.OSL

endif	;(remarques)

;;;;;;;;;;;;;;;;;;;;;;;; DIRECTIVES DE COMPILATION ;;;;;;;;;;;;;;;;;;;;;;;;;;;

IDEAL	; commande pour TASM (masm=khrsse, comme tout produit microsoft)
P386	; mode protg, bien sr !

;;; Directives pour le listing
%noconds
%nocref
%noctls
%noincl
masm
.xall
ideal
%nosyms
%trunc
%list	; let's go

;;;;;;;;;;;;;;;;;;;;;;; BIBLIOTHEQUES DE MACROS ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
Include "Macro.INC"	; usage gnral et programmation structure
Include "Mem386.INC"	; mmoire tendue et mode protg

;;;;;;;;;;;;;;;;;;;;;;; TYPES ET STRUCTURES UTILISES ;;;;;;;;;;;;;;;;;;;;;;;;;

;;; voir NOYAU386.OSL

Struc	SelecteurLong
   NumeroDT	dw	?	; numro de la table de descripteurs
   Selecteur	dw	?	; slecteur de segment dans la table
EndS	SelecteurLong
Struc	AdresseLongue
   NumeroDT	dw	?	; numro de la table de descripteurs
   Selecteur	dw	?	; slecteur de segment dans la table
   Deplacement	dd	?	; dplacement dans le segment
EndS	AdresseLongue



;;;;;;;;;;;;;;;;;;;;;;;;;;; SEGMENTS DU NOYAU ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;; il faudra sans doute prcder les segments d'un entte. Mais le chargeur
;;; pourra s'en charger (hh).

masm	;; s'assurer de l'ordre de compilation des segments
.SEQ
Ideal

Group	Noyau NoyauMemES,DonneesNoyauMemES,NoyauLangage,DonneesNoyauLangage

Segment NoyauMemES dword use32 'OSLN'
EndS	NoyauMemES
Segment DonneesNoyauMemES dword use32 'OSLN'
EndS	DonneesNoyauMemES
Segment NoyauLangage dword use32 'OSLN'
EndS	NoyauLangage
Segment DonneesNoyauLangage dword use32 'OSLN'
EndS	DonneesNoyauLangage

;;;;;;;;;;;;;;;;;;;;;;;;;;;; Entte du noyau ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
Taille_Entete	=	256
Segment	NoyauMemES
Identificateur	db	"Noyau OSLm v0.01 (c) Far 1988,1992",0
ORG 80
Taille_Fichier	dd	Size Noyau
Taille_Noyau	dd	Size Noyau + TailleApresNoyau
ORG 60h
Point_Entree	dw	Init,0		; point d'entre du mode protg
ServiceL1	dd	ofs PorteServiceL1
ServiceL2	dd	ofs PorteServiceL2
ServiceL3	dd	ofs PorteServiceL3

ORG Taille_Entete

EndS	NoyauMemES


;;;;;;;;;;;;;;;;;;;;;;;;;;;; Adresses externes ;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Attention: cette section dfinit les adresses des donnes du fichier
; de chargement OSLC.COM. Les utilitaires (fichiers .XRF ?) livrs avec
; l'assembleur devraient permettre d'utiliser automatiquement de telles
; donnes externes; mais en attendant de savoir les utiliser, me voil
; oblig de servir d'diteur de liens manuel.
;; Les donnes ici consignes correspondent  la version du chargeur du
; 22/8/92.

 ServeurXMS	equ	dwo 100h	; adresse du serveur XMS
 TypeCPU	equ	wo 104h		; Type de micro-processeur
 HandleNoyau	equ	wo 106h		; handle XMS du noyau, 0 pour mmoire
					; conventionnelle
 OffsetNoyau	equ	dwo 108h	; Adresse linaire du noyau, ou
					; seg:0 si dans mmoire DOS
 TailleTampon	equ	wo 10Ch		; Taille du tampon XMS/DOS
 HandleZOT	equ	wo 10Eh		; idem pour la ZOT que pour le noyau
 OffsetZOT	equ	dwo 110h
 GDTReelle	equ	qword 114h	; GDT accessible au noyau rel
 LimiteGDTReelle =	32*8-1		; 32: nombre d'entres
 TaillePile	 =	1024		; Taille de la pile mode rel
 Offsetpile	 =	?		; Adresse de la pile en mode rel

;;;;;;;;;;;;;;;;;;;;;;;; Slecteurs de segment ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; (dont on a tronqu la partie RPL et TI)

 ;;; Table globale de descripteurs pour la tche matresse
S_EntreeVide		=	00h	;(S_ comme slecteur)
S_NoyauMemES		=	08h
S_DonneesNoyauMemES	=	10h
S_PileNoyauMemES	=	18h
S_TacheDeCommutation	=	20h
S_PorteServiceNoyauL1	=	28h
S_PorteServiceNoyauL2	=	30h
S_PorteServiceNoyauL3	=	38h
S_NoyauReel		=	40h	; pour le noyau reel, en tant que code
S_DonneesNoyauReel	=	48h	; idem en tant que donnes
S_Tout			=	50h	; toute la mmoire.
S_ZOT			=	58h	; la ZOT

S_TacheActuelle		=	080h
S_LDT_TacheActuelle	=	088h
S_CodeTacheActuelle	=	090h
S_DonneesTacheActuelle	=	098h
S_PileTacheActuelleL0	=	0A0h
S_PileTacheActuelleL1	=	0A8h
S_PileTacheActuelleL2	=	0B0h
S_PileTacheActuelleL3	=	0B8h

;;;;;;;;;;;;;;;;;;;;;;;; Routines d'accs externe ;;;;;;;;;;;;;;;;;;;;;;;;;;;;

Segment NoyauLangage

Proc	ExecNear far
; Procdure OSL correspondant: (aucune:utilisation implicite si ncessaire)
; Rsultat : xcute une procdure near  partir d'un appel far.
;	CTLR
; Paramtres :
;	- la pile et les registres doivent contenir les paramtres de la
;	procdure near  appeler.
;	- SS:EBP doit pointer vers une structure:
;	 . adresse (4 octets) pour l'adresse
;	 . champ libre (6 octets) pour l'adresse de retour.
; Restrictions:
;	- EBP ne doit pas tre modifi par la routine appele;
;	- la pile est rendue dans l'tat dans lequel la routine near l'a
;	laiss.
		pop	[dwo ss:bp+4]
		pop	[wo ss:bp+8]
		call	[wo ss:bp]
		jmp	[pword bp+4]
	;; mme chose en use 16
	;	pop	[dword ss:bp+2]
	;	call	[word ss:bp]
	;	jmp	[dword ss:bp+2]
EndP		ExecNear

Proc	RepMovsb	near
; Procdure OSL correspondante :
;	- affectation d'une structure de taille n variable
; Paramtres:
;	- DS:ESI contient la source du dplacement
;	- ES:EDI contient la destination du dplacement
;	- ECX
; Rsultats:
;	- le bloc commenant en DS:ESI et s'tendant vers le haut ssi df=0,
;	vers le bas si df=1, et de longueur ECX en octets (ventuellement
;	nulle) est recopi sur le bloc ES:EDI.
;	CTLRS EAX,ECX,ESI,EDI,F
; Remarques:
;	- se comporte presque (donc pas) comme un "Rep Movsb"
;	- effectue en fait un "rep movsd" (donc plus rapide)
;	- rentable seulement pour de larges blocs ( cause de l'appel).
;	- on a tout intrt  recopier ce code ou  l'adapter dans des
;	cas particuliers.
;	- si les blocs se chevauchent, des problmes peuvent avoir lieu.
;	utiliser alors un "InternalRepMovsb", copi sur le InternalRepMovsd
;	du segment NoyauMemES
		mov	eax,ecx
		shr	ecx,2
		and	al,3
		jecxz	repm vsb0
		rep	movsd
	repmovsb0:
		mov	cl,al
		jecxz	repmovsb1
		rep	movsb
	repmovsb1:
		retn
EndP	RepMovsb

EndS	NoyauLangage



;;;;;;;;;;;;;;;;;;;; Appel  des fichiers d'inclusion ;;;;;;;;;;;;;;;;;;;;;;;;
;;;  On pourra si les fichiers sont trop gros assembler sparment, en
;;; incluant  chaque fois les fichiers de dfinition, et en acceptant
;;; des variables externes avec le mot cl extern.

Include "OSL0010N.ASM"	; Dfinitions du mode protg
Include "OSL0011N.ASM"	; Gestion de bas niveau du mode protg
Include "OSL0012N.ASM"	; Interface avec E/S et DOS
;;Include "OSL0013N.ASM"	; Multitche de bas niveau
;;Include "OSL0014N.ASM"	; Multitche de haut niveau
;;Include "OSL0015N.ASM"	; Objets fichiers virtuels
;;Include "OSL0016N.ASM"	; Objets fichiers rels
Include "OSL0020N.ASM"	; Gestion de base de la mmoire: Dfinition
Include "OSL0021N.ASM"	; Objet ZOT
Include "OSL0030N.ASM"	; Constructeurs d'objets: dfinitions
Include "OSL0031N.ASM"	; Constructeurs virtuels d'objets
Include "OSL0032N.ASM"	; Constructeurs rels d'objets
Include "OSL00FFN.ASM"	; Code d'initialisation d'OSLm


