#include "MyTypes.h"

/*#define StrToX_G*/
#include "StrToX.h"

static char isspace (char c)
{
  return (c==32)||(c==13)||(c==10)||(c==9) ;
}

void SkipSpaces(char **i)
{
  while (isspace(**i)) (*i)++;
}

int GetCiffer(char c)
{
  switch (c) {
  case 'A':
  case 'B':
  case 'C':
  case 'D':
  case 'E':
  case 'F':
    return c + 10 - 'A';
  case 'a':
  case 'b':
  case 'c':
  case 'd':
  case 'e':
  case 'f':
    return c + 10 - 'a';

  default:
    if ((c>='0')&&(c<='9')) return c - '0';
	       else return -1;
  }
}

long GetNumber(char *s,char**i,unsigned char b)
{
  /*
  - Lit un nombre en base b dans la chane de caractres s, et fait
   pointer *i sur la suite.
  - *i vaut s s'il n'y a pas de nombre, suprieur  la longueur de la chane.
  - n vaut alors zro, mais mieux vaut ne pas s'y fier.
  - Il n'y a PAS de test explicite de dbordement pour le nombre.
  */
  long n;
  long c;

  for ((*i)=s,n=0 ; (unsigned)(c=GetCiffer(**i))<b ; (*i)++)
      n = n * b + c;
  return n;
}

long GetInteger(char *s, char** i)
{
  /*
  - prend un nombre dans une chane de caractres s et fait
   pointer *i sur la suite.
  - Le nombre peut tre prcd d'un signe.
  - ll peut tre en base 10 ou 16. Par dfaut, ce sera 10;
   un dollar active la base 16.
  - s'il n'y a pas de nombre, i vaut s.
  - Des espacements peuvent prcder le nombre, ou sparer le signe et
   les chiffres.
  */

  char *j, *k ;
  unsigned char b;
  long n;
  boolean Minus;

  (*i) =j = s;
  SkipSpaces(&j);
  if (*j == '-') {
    Minus = True;
    j++;
  } else
    Minus = False;
  SkipSpaces(&j);
  if (*j == '$') {
    b = 16;
    j++;
  } else
    b = 10;
  n = GetNumber(j, &k, (int)b);
  if (Minus)
    n = -n;
  if (k > j)
    *i = k;
  return n;
}


/************** TEST *******
#include <stdio.h>
main ()
{
 char * i ;
 long n ;
 char s[255] ;

 scanf ("%s",&s) ;
 n = GetInteger(s,&i) ;
 printf("%d",n);
 return 0;
}
********/