/******************* Unit StrToX **************/
/*
v.1.0
Includes:
- skipping spaces.
- char to hex ciffer conversion.
- string to integer conversion.
In the future:
- string to real conversion.
- use of I/O object in lieu of strings.
*/
/*
This is copyright (c) Franois-Ren "Far" Rideau June 1993
You may freely distribute or modify it, but please keep
my address inside it, and send me modified version.
My addresses are:
- rideau@clipper.ens.fr
- 6, rue Augustin Thierry 75019 Paris FRANCE
*/


#ifndef StrToX_H
#define StrToX_H

#ifdef StrToX_G
  #define vextern
#else
  #define vextern extern
#endif

void extern SkipSpaces (char **i);
int extern GetCiffer (char c);
long extern GetNumber (char *s, char**i, unsigned char b);
long extern GetInteger (char *s, char**i);

#undef vextern
#endif /*StrToX_H*/

