/*
   Copyright (c) 1990
   Far Rideau DVB
   6 rue Augustin Thierry
   75019 Paris FRANCE
   42.02.67.35
*/
/*  Ce fichier, (une fois fini) , contiendra des routines permettant le
   traitement d'expression algbriques formelles composes de symboles, de
   fonctions, et d'oprateurs, sous les formes indiffrencies de chanes
   de caractres, de listes chanes, ou d'expressions en notation postfixe
   permettant une valuation rapide, tenant compte des proprits de commu-
   tativit, d'associativit ventuelles des oprations.
    ( Les deux premires formes seront traites en premier )
*/
/* Liste des classes
 Value
 Label
 Operator
 Lexistr
 Expression
 PostFixedE
*/

#define	DEBUG

#include <string.h>
#include <alloc.h>
#include <math.h>


////////		DEFINITIONS
#include "macro.h"
#include "mystring.h"
#include "erreur.h"

#include "alg0.cpp"	// dfinition des tiquettes
#include "alg1.cpp"	// valuation d'expressions en notation postfixe
#include "alg2.cpp"	// transformation d'une expression vers la notation
			// postfixe



