/*
 Commenc le 17/8/91
*/
/*
 Tentative de critique de langages de programmation et systmes de
 dveloppement dj existant .


* Assembleur :
  Les assembleurs manquent de portabilit . Jusqu'ici, aucun n'assembleur ne
permet un traitement convenable de nombres  virgule flottante . Les 
programmes en assembleur sont tout aussi fastidieux  crire qu' lire .
  De plus, mais la faute de ceci incombe aux autres langages, il est
difficile de mlanger efficacement du code en assembleur  du code produit
par d'autres langages, faute de savoir comment ces autres langages 
organisent la mmoire, les registres, et faute de pouvoir le paramtrer .
  Un bon point : les bonnes ides des dfinitions de Macro, qui n'ont 
malheureusement pas t suivies par les autres langages .

* Basic,Pascal,C :
  Ces langages se ressemblent actuellement, et toute innovation dans une
mouture de l'un est reprise tt ou tard dans une mouture de l'autre . Ils
fonctionnent maintenant tous sur le mme principe, seule la syntaxe change .

Basic   : Le Basic de base est nul ; les Basic rcents ne sont que des Pascal
	avec la syntaxe obsolte du Basic, mais ayant encore des tares du
	Basic, mauvais traitement des donnes structures, non prdclaration
	des donnes obligeant  les redclarer  chaque fois par un suffixe.
LSE	: Vieux mlange Basic-Pascal franais . Moins bien que le Pascal .
Pascal	: Le Pascal est lisible, mais sinon est moins bien que le C en tout
	autre point , sauf le WITH qui est pratique, mais que l'on peut
        contourner en C avec un #define, et les dfinitions locales de
        fonctions et procdures, pourtant trs utiles  une programmation
	sainement structure .
C,C++	: Moins lisible que les langages prcdents, mais plus puissant .
	Le prprocesseur, absent dans les langages prcdents, ne pousse pas
	assez loin l'ide de macrodfinition, que l'on a pas fait voluer
	depuis (il est relativement  la puissance du langage moins volu 
	que celui des macros-assembleurs) .
	  Le concept d'objet, pouss plus loin dans le C++ que dans les
	langages prcdents, ne permet nanmoins pas l'intgration vritable
	de nouveaux objets  l'environnement .

  Aucun de ces langages ne possde de dialogue avec le compilateur, ou alors
ce dialogue est troit, frustrant, et livr comme un gadget . Le dialogue
serait pourtant important pour regrouper codes et donnes selon la manire
dont on aurait besoin d'eux dans l'environnement multitche maintenant de
rigueur (et qui l'a toujours t) : certaines portions de code, rutiliss
par de nombreux programmes (notamment calcul sur des nombres rels, routines
d'affichage et/ou d'interface avec l'utilisateur, le matriel, et le
systme) sont prsentes dans chacun d'eux, au lieu de l'tre une fois pour
toute dans de systme ; il n'est pas prvu de sparation des donnes entre
les tches au niveau du compilateur .
  Ne sont pas grs non plus des types d'objets de taille variable ou
indfinie  priori, pourtant indispensables quand un programme fait quelque
chose qui ressemble de prs ou de loin  de l'intelligence artificielle ( et
tous les programmes un tant soit peu interessants, sauf certains programmes
de calculs rptitifs  grande chelle, fait de l'intelligence artificielle
 quelque niveau, sinon, un ordinateur	serait absolument inutile pour
xcuter la tche ) . Cette grave lacune oblige souvent le programmeur  
bidouiller,  bricoler avec les moyens du bord, ce qui lui fait perdre son 
temps pour une variation sur un thme connu, allonge ses programmes, et 
diminue leur portabilit pour les faire interagir avec d'autres programmes .


  De plus, les diteurs sont souvent navrant, n'autorisant pas une
dclaration automatique des variables et des routines, ni la visualisation
d'objets de type nouveau avec des routines paramtrables rajoutes au
systme ; mme la visualisation des routines et donnes de type prxistant
est ardue, l'environnement ne permettant pas une personnalisation de chaque
donne au niveau du systme entier ; enfin, ces environnements  compilateurs
ne permettent pas de lancer une routine test avec des paramtres tests pour
vrifier son bon fonctionnement (les exceptions sont les langages interprts
lents au possible) .
  Bref, l'environnement n'est ni tendu, ni extensible par l'utilisateur,
soumis  la bonne grce des diteurs , et ne permet pas un dbogage facile ou
une une utilisation comme accessoire de travail des programmes crits .
L'implmentation d'un langage corrigeant ces dtails tous  la fois serait
trs certainement fort apprci du public .
  Tous ces langages apparaissent comme ayant t conu pour des systmes
avec une interface peu dveloppe,  savoir une entre et une sortie
linaires et lentes de caractres, ( preuve en est l'criture purement
textuelle et linaire des programmes ) et o l'aspect multitche a t
nglig ou surrajout . Aussi, aucun ne tient compte dans sa structure mme
de l'ordinateur sur lequel il va fonctionner, son environnement graphique, et
sa mmoire, qui permettent maintenant de crer un vritable systme de
dveloppement alors qu' l'poque de conception de ces langages, la machine
 crire modifie tait le terminal pour lequel ils ont t conus .
  On en est alors rduit  programmer des programmes sophistiqus avec ces
langages primaires !!!

* Forth
  Le Forth demande un plus grand effort de rflexion  la programmation que
les langages prcdents, pour calculer le niveau d'une donne dans la pile .
Ce devrait tre automatis, ainsi que le calcul d'expressions ( avec aide
humaine pour amliorer ), tout en conservant l'expression originale pour la
pouvoir modifier aisment .
  Le Forth de base, avec une pile d'entier, supporte difficilement le calcul
sur des nombres  virgule flottante .
  Les Forth avec une pile de donne o il faut interprter soit mme le
sens des donnes et connatre leur longueur, est lent de programmation, peu
puissant, avec un accs difficile aux donnes . Si la donne de base est
de taille suprieure  un mot du processeur, il y a perte de mmoire, et
ralentissement du traitement des donnes . Sinon, il y a difficult de
traitement de donnes de taille suprieure .
  Les Forth avec une pile de pointeurs sur des donnes structures permet
un meilleur accs aux donnes , mais ralenti le calcul sur des donnes
simples . Par ailleurs, il faudrait un accs paramtrable  ces donnes
pour permettre la cration et l'utilisation de nouveaux types d'objets, ce
qui n'est pas fait jusqu' prsent .
  Un dernier dtail blmable est la non adaptation du Forth aux matriels
existant . Mais l'on peut blmer pour cela les matriels en question plutt
que le Forth, selon le point de vue .
  Pour amliorer le Forth, il faudrait que l'environnement accepte plusieurs
niveaux de compilation, et des piles de types diffrents (voir le Projet) .

* Une heureuse exeption  la rgle
  Le seul langage actuellement disponible qui a t conu pour un ordinateur,
et tire parti de toutes ses possibilits, est le RPL, langage que HP a donn
 ses calculatrices modles 28 et 48 . Malheureusement, ces calculatrices
sont limites d'elles-mme dans leur puissance et dans leur interface, de
par la taille de l'cran et le clavier lent de calculatrice, et le manque
relatif de vitesse du processeur ( par rapport  un ordinateur, pas par
rapport  une calculatrice ) . Ce langage en effet est un systme de
dveloppement  par entire, permettant des raccourcis s'il en est besoin,
facilement extensible comme le Forth dont il est issu, incluant des
possibilits de calcul complexe, matriciel et symbolique, ainsi que des
routines de traitement de listes hrites du Lisp, aux notations beaucoup
plus simples, et que des facilits de programmation prises au Pascal .
  Ce qui lui manque est ce qui ne tient pas dans la calculatrice,  cause
de sa lenteur et de son manque de mmoire : une interface graphique, une
gestion multitche et donc multipile, ainsi qu'un compilateur complet.
  De plus, cet environnement a t conu exprs avec la machine, et le
clavier avec ses touches de raccourci fait partie intgrante du langage. En
adaptant le langage pour un ordinateur, il faudra aussi adapter l'interface.



*/
/*
 Ici sont rpertoris des langages plus mal connus
* Lisp				
  Le Lisp n'apparait que comme un Forth avec notation prfixe au lieu de
postfixe (un Forth o l'on utiliserait des listes au lieu de piles). Ceci 
complique l'criture  cause d'une multitude de parenthses qu'un bon 
diteur devrait grer automatiquement, et diminue la puissance du langage 
au profit de sa rigueur (comme le Pascal par rapport au C dans d'autres
domaines) .

* Prolog (le langage marseillais d'I.A.)
  Prolog est un langage tellement spcialis qu'il est plus un outil de
programmation qu'un langage, de par sa structure algorithmique limitative .
Il ne permet notamment pas de grer une interface avec l'utilisateur, ce que
tout environnement complet de programmation devrait permettre . Mais s'il
tait considr comme un outil  utiliser avec d'autres langages, si Prolog
tait amnag en consquence, ainsi que son diteur, qui pourrait aussi tre
amnag pour tirer parti des environnements graphiques aujourd'hui
disponibles .

* Smalltalk
  Smalltalk apparat d'aprs le peu qui en est connu, comme un langage
ayant invent le concept d'objet ; mais il apparat comme s'tant concentr
uniquement sur ces objets, et leur comportement, au dfaut d'une
programmation qui se voudrait performante (rapide  l'xcution, le moins
gourmand possible en mmoire) . La non conception du langage pour la
compilation en tmoigne, ainsi que la notation inhabituelle pour les calculs

*/

