////////		DEFINITIONS

typedef	unsigned int	Word ;
typedef unsigned long	dword;

#define LONG(seg,ofs)	( (long)( ((void _seg*)seg) + ((void near*)ofs) ) )
#define WORD(HI,LO)	( (Word)( HI << 8 + LO) )
#define LLo(x)		((Word)(x))
#define LHi(x)		((Word)((dword)(x) >> 16))
#define Lo(x)		((char) ((x)&0xff) )
#define Hi(x)		((char)  ((x)>>8)  )

#define ObjLen(x)	x,sizeof(x)

#define TAB		'\x9'
#define LF		'\xA'
#define CR		'\xD'
#define SPC		' '

#define Carry		(_FLAGS&1)

#define MAX(x,y)	( (x) > (y) ? (x) : (y) )
#define MIN(x,y)	( (x) < (y) ? (x) : (y) )

char HexDigit(register char h)
{
 if ( h>='0'&& h<='9' )	return h-'0';
 if ( h>='a' )		h-='a'-10;
 else			h-='A'-10;
 if ( h>=10 && h<16 )	return h;
 else			return -1;
}
/*
char pascal near HexDigit (char h);

void nop (void)
{
return ;

asm { HexDigit proc near
	pop bx ; pop ax
	xor ah,ah
	sub al,'0'
	jb notahd
	cmp al,9
	jbe okman
	sub al,'A'-'0'-10
	cmp al,10
	jb notahd
	cmp al,10h
	jb okman
      notahd:
	mov ax,-1
      okman:
	jmp bx
      HexDigit endp
    }
}
*/

inline int isspace(char c)
  { return c==SPC||c==TAB||c==LF;}
inline int isdigit(char c)
  { return c>='0' && c<='9';}
inline int isupper(char c)
  { return c>='?' && c<='Z';}
inline int islower(char c)
  { return c>='_' && c<='z';}
inline int isaccnt(char c)
  { return c>=128 && c<=155;}
inline int isletter(char c)
  { return isupper(c)||islower(c); }


asm
{
 Macro @@MINZBIT
 Local _loop
  mov ax,-1
 _loop:
  inc ax
  shr bx,1
  jc loop
 EndM

 Macro @@MAXNZBIT
 Local _loop,_out
   mov ax,8
  _loop:
   dec ax
   jc  _out
   shl bl,1
   jnc _loop
   mov ax,0
  _out:
 EndM

}


inline int MinZBit ( int Bit )
 {asm
  {
   mov bx,Bit
   @@MINZBIT
 }}

inline int MaxNZBit ( char Bit )
 {asm
  {
   mov bl,Bit
   @@MAXNZBIT
 }}
